###Writes all custom NEMA_functions scripts to a specified folder

###input
#file_script (script of which you want to get the NEMA_functions from)
#NEMA_functions_dir (location of the nema functions)
#write_dir (location where to write to, standard is current wd to a folder called "Function_scripts")

###output
#a folder with functions

###Description

NEMA.get.functions <- function(file_script,NEMA_functions_dir,write_dir="Function_scripts"){
                               if(missing(file_script)){               stop("requires a source script")}
                               if(missing(NEMA_functions_dir)){        NEMA_functions_dir <- "E:/Nemawork/Projects_R_zone/Git/NEMA_functions"}

                               ###get write_dir
                                   dir.create("Function_scripts", showWarnings = F)
                                   write_dir <- paste(getwd(),write_dir,sep="/")
  
                               ####compile a list of the nema functions as currently exist
                                   functionlist <- dir(paste(NEMA_functions_dir,"/R/",sep=""))
                               ###remove the .R
                                   functionlist <- gsub(".R$","",functionlist)
                               
                               ###load source script
                                   sourcescript <- read.table(file = file_script,sep="\n",comment.char="",blank.lines.skip = FALSE,quote="")
                               
                               ###search in source script
                                   output <- NULL
                                   for(i in 1:length(functionlist)){
                                       output <- c(output,grepl(functionlist[i],sourcescript))
                                   }
                               
                               ###Go through five times for nested functions
                               ###load source script
                                   for(k in 1:5){
                                       for(j in which(output)){
                                           sourcescript <- read.table(file = paste(NEMA_functions_dir,"/R/",functionlist[j],".R",sep=""),sep="\n",comment.char="",blank.lines.skip = FALSE,quote="")
                                           
                                           ###search in source script
                                           for(i in 1:length(functionlist)){
                                               if(grepl(functionlist[i],sourcescript)){
                                                   output[i] <- TRUE
                                               }
                                           }
                                       }
                                   }
                               
                               ###copy functions to folder
                               for(i in which(output)){
                                   file.copy(from = paste(NEMA_functions_dir,"/R/",functionlist[i],".R",sep=""), to = write_dir) 
                               }                        
}
