### Enrichment figure

setwd("E:/OneDrive - Wageningen University & Research/Shared_data_Mark/Projects/Qi_Zheng/Qi_RNAseq/R/enrichment")


###Set plotting theme
    presentation <- theme(axis.text.x = element_text(size=10, face="bold", color="black"),
                          axis.text.y = element_text(size=10, face="bold", color="black"),
                          axis.title.x = element_text(size=12, face="bold", color="black"),
                          axis.title.y = element_text(size=12, face="bold", color="black"),
                          strip.text.x = element_text(size=12, face="bold", color="black"),
                          strip.text.y = element_text(size=12, face="bold", color="black"),
                          plot.title = element_text(size=14, face="bold"),
                          strip.background = element_rect(fill= "grey80",color="black"),
                          panel.background = element_rect(fill = "white",color="black"),
                          panel.grid.major = element_line(colour = "grey80"),
                          panel.grid.minor = element_blank(),
                          legend.position = "right")


library(tidyverse)
library(RColorBrewer)

files <- dir()[grepl(".csv",dir())]


data.plot <- read.csv(files[2]) %>%
             arrange(negative_log10_of_adjusted_p_value) %>%
             mutate(term_name=factor(term_name,levels = unique(term_name))) %>%
             mutate(fold_enrichment=intersection_size/(term_size/effective_domain_size*query_size))







ggplot(data.plot,aes(y=term_name,x=negative_log10_of_adjusted_p_value,colour=term_size)) +
geom_point(aes(size=fold_enrichment)) + presentation + scale_color_gradientn(colours=brewer.pal(9,"Reds")[-c(1,2)]) +
labs(x=expression(bold(-log[10](corrected~bolditalic(P)~value))),y="GO-term") + theme(legend.position = c(0.8,0.3)) +
xlim(0,5) + geom_vline(xintercept = 1.3,col="blue",size=1.5,lty=2)
